"""
Copyright 2009, Red Hat, Inc
Michael DeHaan <mdehaan@redhat.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301  USA
"""

import exceptions
#from cexceptions import *
#import utils

class ProxyCollection:

    def __init__(self,api,collection_type):
        self.api = api
        self.collection_type = collection_type

    def __iter__():
        values = self.api.item_names(collection_type)
        for name in values:
           yield ProxyObject(self.api, name, collection_type)

class ProxyItem:

    def __init__(self, api, name, collection_type):
        self.api = api
        self.name = name
        self.collection_type = collection_type

    def __getattr__(self, attribute):
        if attribute in "name":
            return self.name
        else:
            if not self.obj:
                if collection_type == "distro":
                   self.obj = self.api.get_distro(name)
                elif collection_type == "profile":
                   self.obj = self.api.get_profile(name)
                elif collection_type == "system":
                   self.obj = self.api.get_system(name)
                elif collection_type == "repo":
                   self.obj = self.api.get_repo(name)
                elif collection_type == "image":
                   self.obj= self.api.get_image(name)
            return self.obj.__getattr__(attribute)     
     
